// Author:       Andreas F. Borchert
// Description:  sinus function as extension of Function

#include <string>
#include "SayBye.h"

std::string SayBye::get_name() const {
   return "sagHallo";
} // SayBye::get_name()

std::string SayBye::execute(std::string str) const {
   return "Tschau " + str;
} // SayBye::execute

extern "C" Function* construct() {
   return new SayBye();
}

