// Author:       Andreas F. Borchert
// Description:  sinus function as extension of Function

#include <string>
#include "SayHello.h"

std::string SayHello::get_name() const {
   return "sagHallo";
} // SayHello::get_name()

std::string SayHello::execute(std::string str) const {
   return "Hallo " + str;
} // SayHello::execute

extern "C" Function* construct() {
   return new SayHello();
}

