// Author:       Andreas F. Borchert
// Description:  test of function registry

#include <iostream>

#include "DynFunctionRegistry.h"

#include <vector>
#include <dirent.h>
#include <string>
#include <cstring>


using namespace std;

int main() {
   DynFunctionRegistry registry(".");

   string fname; std::string x; std::string flag;
   bool found;

   while (cout << ": " &&
          cin >> fname >> x) {
      found = false;
      if (registry.is_known(fname)) {
         Function* f(registry.get_function(fname));
         cout << f->execute(x) << endl;
      } else {
         cout << "Unknown function name: " << fname << endl;
	 cout << "Versuche eine Datei mit dem Namen " << fname 
			<< " zu kompilieren " << endl;


	// Ein Fileobjekt bauen, das wir suchen
	std::string file = fname + ".C";
	// schaun wir mal, ob es eine *.C-Datei dafuer gibt	
	DIR *directory;
	// Verzeichnis oeffnen
	directory = opendir("./");

	struct dirent *dirEntry;
	// und alle Eintraege durchgehen
	while((dirEntry=readdir(directory))) {
	   // auf Dateiendung ueberpruefen
	   // geht vielleicht eleganter???
	   if(strstr(dirEntry->d_name, file.c_str()) != 0) {
		// Dateinamen gefunden
		// in String verwandeln
		std::string str(dirEntry->d_name);
		std::string command = "g++ -o " + fname + ".so -fPIC -shared " + fname +".C";
		std::system(command.c_str());
		found = true;
		break;
	   }
	} // while
	closedir(directory);
	if (found) {
	   cout << fname << " steht nun zur verfuegung" << endl;
	} else {
	   cout << fname << " nicht gefunden...." << endl;
	} // if
      } // if
   }  // while commando
} // main
