// Author:       Andreas F. Borchert
// Description:  sinus function as extension of Function

#include <cmath>
#include <string>
#include "getDir.h"
#include <cstring>
#include <vector>
#include <dirent.h>
#include <iostream>

std::string getDir::get_name() const {
   return "sagHallo";
} // getDir::get_name()

std::string getDir::execute(std::string path) const {
	DIR *directory;
	directory = opendir(path.c_str());

	std::string content;
	struct dirent *dirEntry;


	if(directory == 0) {
		//retVal = 0;
	} else {
		while((dirEntry=readdir(directory))) {
			// auf Dateiendung ueberpruefen
			// geht vielleicht eleganter???
			
//			if(strstr(dirEntry->d_name,".o")!= 0) {
				std::string str(dirEntry->d_name);

//			}
			content += str + "\n";
		}
	}
	closedir(directory);
   return content;
} // getDir::execute

extern "C" Function* construct() {
   return new getDir();
}

